renommer des plans qui se trouvent dans un set géométrique

Voir le sujet précédent Voir le sujet suivant Aller en bas

renommer des plans qui se trouvent dans un set géométrique

Message par xorman le Mer 15 Oct 2014 - 21:45

Bonjour
Je veux renommer les plans (plan.xxxx) qui se trouvent dans un set géométrique.
J'arrive à sélectionner les plans qui se trouvent mon set géométrique ("Constructions geometriques")


Sub CATMain()

Dim partDocument1 As PartDocument

'test si c'est un CATPART
On Error Resume Next
   Set partDocument1 = CATIA.ActiveDocument
On Error GoTo 0
If partDocument1 Is Nothing Then
   MsgBox "Lancer la macro depuis un CATPart actif!", vbExclamation, "Product non actif"
   Exit Sub
End If

'SELECTIONNE LES PLAN DANS LE SET GÉOMÉTRIQUE
Dim selection1 As Selection
Set selection1 = partDocument1.Selection
Dim part1 As Part
Set part1 = partDocument1.Part

Dim hybridBodies1 As HybridBodies
Set hybridBodies1 = part1.HybridBodies
Dim myhybridBody As HybridBody
Set myhybridBody = hybridBodies1.Item("Constructions geometriques")
selection1.Add myhybridBody

selection1.Search "(CATPrtSearch.Plane.Name=*plan* - (CATPrtSearch.Plane.Name='Plan xy'+ CATPrtSearch.Plane.Name='Plan yz'+ CATPrtSearch.Plane.Name='Plan zx')),sel"
selection1.Search "(CATPrtSearch.Plane.Name=*plan*),sel"


Question voila ce que je veux faire:  pour chaque plans qui se trouvent dans la sélection, je veux renommer ce plan Question

'RENOMMAGE DES PLANS
Dim Plan As HybridShapePlaneOffset
Dim i As Integer
For Each Plan In selection1                  ..........je bloque ici Exclamation! Laughing
Plan.Name = "P" & i               ' nouveau nom du plan
i = 1 + 1
Next

xorman
actif
actif

Messages : 93
Date d'inscription : 06/09/2008
Age : 40
Localisation : Cherbourg

http://www.myimpression3d.com

Revenir en haut Aller en bas

Re: renommer des plans qui se trouvent dans un set géométrique

Message par Guss_ le Jeu 16 Oct 2014 - 3:32

D'après ce que je comprends tu cherches tout les plans dont tu veux changer le nom.

Je pense qu'il y a un "count" a faire


i = selection1.count

for b_boucle=1 to i
selection(i).Name = "P" & i
i = 1 + 1
Next



ou un truc dans le même esprit

Guss_
Fédérateur
Fédérateur

Messages : 498
Date d'inscription : 08/01/2010

Revenir en haut Aller en bas

Re: renommer des plans qui se trouvent dans un set géométrique

Message par xorman le Jeu 16 Oct 2014 - 4:45

oui tu as raison.....j'ai trouver entre temps..voici le code ....merci guss

Dim Element As HybridShape
Dim NameElement As String
Dim i As Integer
Dim NbPlan As Integer
Dim NbSurface As Integer

Dim myHybridBodies As HybridBodies
Set myHybridBodies = myHybridBody.HybridBodies

UserFormSelectionElement.Show      'montre la fenètre de fin de traitement

For i = 1 To myHybridBodies.Count
   For Each Element In myHybridBodies.Item(i).HybridShapes
   NameElement = Element.Name
   Debug.Print NameElement
   If Left(NameElement, 4) = "Plan" Then
       Element.Name = "p" & Mid(NameElement, 6)
       NbPlan = NbPlan + 1
   End If
   If Left(NameElement, 7) = "Surface" Then
       Element.Name = "s" & Mid(NameElement, 9)
       NbSurface = NbSurface + 1
   End If
   Debug.Print Element.Name
   Next
Next

xorman
actif
actif

Messages : 93
Date d'inscription : 06/09/2008
Age : 40
Localisation : Cherbourg

http://www.myimpression3d.com

Revenir en haut Aller en bas

Re: renommer des plans qui se trouvent dans un set géométrique

Message par Guss_ le Jeu 16 Oct 2014 - 19:18

cool Smile

C'est vrais que ça peut être très utile ce genre de macro

Guss_
Fédérateur
Fédérateur

Messages : 498
Date d'inscription : 08/01/2010

Revenir en haut Aller en bas

Re: renommer des plans qui se trouvent dans un set géométrique

Message par Contenu sponsorisé


Contenu sponsorisé


Revenir en haut Aller en bas

Voir le sujet précédent Voir le sujet suivant Revenir en haut

- Sujets similaires

 
Permission de ce forum:
Vous ne pouvez pas répondre aux sujets dans ce forum